require "defines"

trees = {
  --"dead-dry-hairy-tree",
  --"dead-grey-trunk",
  --"dead-tree",
  --"dry-hairy-tree",
  --"dry-tree",
  --"green-coral",
  "tree-01",
  "tree-02",
  "tree-02-red",
  "tree-03",
  "tree-04",
  "tree-05",
  "tree-06",
  "tree-06-brown",
  "tree-07",
  "tree-08",
  "tree-08-brown",
  "tree-08-red",
  "tree-09",
  "tree-09-brown",
  "tree-09-red"
}

function generate_trees(event)
  
  -- bottom left of the chunk
  minx = event.area.left_top.x
  miny = event.area.left_top.y
  
  -- bottom right of the chunk
  maxx = event.area.right_bottom.x
  maxy = event.area.right_bottom.y

  -- iterate left to right
  for x = minx, maxx do
  
    -- iterate up to down
    for y = miny, maxy do
      
      -- chose random tree type
      tree_type = trees[math.random(1, #trees)]
      
      -- spawn tree
      if game.get_surface(1).can_place_entity{name = tree_type, position = {x, y}} then
        game.get_surface(1).create_entity{name = tree_type, position = {x, y}}
      end
      
    end
  end
end

script.on_event(defines.events.on_chunk_generated, generate_trees)